2018中国大学生程序设计竞赛

题目传送门:http://acm.hdu.edu.cn/showproblem.php?pid=6447

YJJ's Salesman

Time Limit: 4000/2000 MS (Java/Others)    Memory Limit: 65536/65536 K (Java/Others)
Total Submission(s): 919    Accepted Submission(s): 290

Problem Description

YJJ is a salesman who has traveled through western country. YJJ is always on journey. Either is he at the destination, or on the way to destination.
One day, he is going to travel from city A to southeastern city B. Let us assume that A is (0,0) on the rectangle map and B (109,109). YJJ is so busy so he never turn back or go twice the same way, he will only move to east, south or southeast, which means, if YJJ is at (x,y) now (0x109,0y109), he will only forward to (x+1,y)(x,y+1) or (x+1,y+1).
On the rectangle map from (0,0) to (109,109), there are several villages scattering on the map. Villagers will do business deals with salesmen from northwestern, but not northern or western. In mathematical language, this means when there is a village k on (xk,yk) (1xk109,1yk109), only the one who was from (xk1,yk1) to (xk,yk) will be able to earn vk dollars.(YJJ may get different number of dollars from different village.)
YJJ has no time to plan the path, can you help him to find maximum of dollars YJJ can get.

Input

The first line of the input contains an integer T (1T10),which is the number of test cases.
In each case, the first line of the input contains an integer N (1N105).The following N lines, the k-th line contains 3 integers, xk,yk,vk (0vk103), which indicate that there is a village on (xk,yk) and he can get vk dollars in that village.
The positions of each village is distinct.
 

Output

The maximum of dollars YJJ can get.
 
Sample Input
1
3
1 1 1
1 2 2
3 3 1
Sample Output
3
 
Source

题目大意:

有N个村庄 [ 横纵坐标为 x , y ( x , y >= 1 && x , y <=1e9 ) ] , 每到一个村庄 我们可以选择向上向右或者向右上方走,每个村庄有一个贡献值,只有当我是从左下方的村庄来的才可以得到当前村庄的贡献值。

解题思路:

离散化 +排序+树状数组维护区间最大值

坐标 x, y 的范围太大,而节点范围还可以,所以不妨离散化一波(听说实际测试数据范围没有到1e9,出题人就料定我们没有这个胆)。

一开始用传统 dp ,状态转移很好想,但很明显会超时,交了两波TLE果断自闭。

这道题是正确打开方式是线段树或者树状数组维护区间最大值,而这里的区间是 y 的区间。然后通过前一行的最优值去转移得到当前行的最优值,不过排序顺序需要注意,因为只有左下方的可以转移过来所以当 x 相同时,优先处理 y 大的。

AC code:

 1 #include <bits/stdc++.h>
 2 #define ll long long int
 3 #define INF 0x3f3f3f3f
 4 #define mod 1000000007
 5 using namespace std;
 6 
 7 const int MAXN = 1e5+10;
 8 
 9 struct date{
10     int x, y, v;
11 }node[MAXN];
12 
13 int d[MAXN], dp[MAXN];
14 int t[MAXN<<1];
15 int N;
16 
17 bool cmp1(struct date a, struct date b)
18 {
19     if(a.x == b.x) return a.y > b.y;
20     return a.x < b.x;
21 }
22 int lowbit(int x)
23 {
24     return x&(-x);
25 }
26 void add(int st, int val)
27 {
28     for(int i = st; i <= MAXN; i+=lowbit(i))
29         t[i] = max(t[i], val);
30 }
31 int query(int st)
32 {
33     int res = 0;
34     for(int i = st; i > 0; i-=lowbit(i))
35         res = max(res, t[i]);
36     return res;
37 }
38 
39 int main()
40 {
41     int T;
42     scanf("%d", &T);
43     while(T--){
44         scanf("%d", &N);
45         memset(t, 0, sizeof(t));
46         for(int i = 1; i <= N; i++){
47             scanf("%d%d%d", &node[i].x, &node[i].y, &node[i].v);
48             d[i] = node[i].y;
49         }
50         sort(d+1, d+N+1);
51         int last = unique(d+1, d+1+N)-1-d;
52         for(int i = 1; i <= N; i++)
53             node[i].y = lower_bound(d+1, d+1+last, node[i].y)-d;
54         sort(node+1, node+1+N, cmp1);
55         for(int i = 1; i <= N; i++)
56         {
57             int res = query(node[i].y-1) + node[i].v;
58             add(node[i].y, res);
59         }
60         printf("%d
", query(MAXN-1));
61     }
62     return 0;
63 }
View Code
原文地址:https://www.cnblogs.com/ymzjj/p/9537617.html